<?php

declare(strict_types=1);

namespace Dedi\SyliusMigrationPlugin\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;

class HandlerPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container): void
    {
        $handlerRegistryDefinition = $container->getDefinition('dedi_migration_handler_registry');

        $serviceIds = $container->findTaggedServiceIds('dedi_migration_handler');

        foreach ($serviceIds as $serviceId => $tags) {
            $handlerDefinition = $container->getDefinition($serviceId);
            $handlerRegistryDefinition->addMethodCall('addHandler', [$handlerDefinition]);
        }
    }
}
